GNU bug report logs - #12613
Subordinate libltdl builds convenience library when it should build shared library

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: libtool; Reported by: Bob Friesenhahn <bfriesen@HIDDEN>; dated Wed, 10 Oct 2012 02:32:01 UTC; Maintainer for libtool is bug-libtool@HIDDEN.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 11 Oct 2012 14:20:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 11 10:20:15 2012
Received: from localhost ([127.0.0.1]:39581 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TMJcU-0003zd-CW
	for submit <at> debbugs.gnu.org; Thu, 11 Oct 2012 10:20:14 -0400
Received: from eggs.gnu.org ([208.118.235.92]:52498)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <bfriesen@HIDDEN>) id 1TMJcS-0003zS-Vr
	for submit <at> debbugs.gnu.org; Thu, 11 Oct 2012 10:20:13 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <bfriesen@HIDDEN>) id 1TMJbZ-0001VU-EV
	for submit <at> debbugs.gnu.org; Thu, 11 Oct 2012 10:19:23 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-6.9 required=5.0 tests=BAYES_00,RCVD_IN_DNSWL_HI
	autolearn=unavailable version=3.3.2
Received: from lists.gnu.org ([208.118.235.17]:47061)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <bfriesen@HIDDEN>) id 1TMJbZ-0001VO-BR
	for submit <at> debbugs.gnu.org; Thu, 11 Oct 2012 10:19:17 -0400
Received: from eggs.gnu.org ([208.118.235.92]:47902)
	by lists.gnu.org with esmtp (Exim 4.71)
	(envelope-from <bfriesen@HIDDEN>) id 1TMJbR-00065b-FZ
	for bug-libtool@HIDDEN; Thu, 11 Oct 2012 10:19:17 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <bfriesen@HIDDEN>) id 1TMJbH-0001SE-MC
	for bug-libtool@HIDDEN; Thu, 11 Oct 2012 10:19:09 -0400
Received: from blade.simplesystems.org ([65.66.246.74]:40145)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <bfriesen@HIDDEN>)
	id 1TMJbH-0001R4-E8; Thu, 11 Oct 2012 10:18:59 -0400
Received: from freddy.simplesystems.org (freddy.simplesystems.org
	[65.66.246.65])
	by blade.simplesystems.org (8.14.4+Sun/8.14.4) with ESMTP id
	q9BEIiA4025294; Thu, 11 Oct 2012 09:18:44 -0500 (CDT)
Date: Thu, 11 Oct 2012 09:18:43 -0500 (CDT)
From: Bob Friesenhahn <bfriesen@HIDDEN>
X-X-Sender: bfriesen@HIDDEN
To: "Gary V. Vaughan" <gary@HIDDEN>
Subject: Re: bug#12613: Subordinate libltdl builds convenience library when
	it should build shared library
In-Reply-To: <alpine.GSO.2.01.1210101102210.18471@HIDDEN>
Message-ID: <alpine.GSO.2.01.1210110856430.27589@HIDDEN>
References: <alpine.GSO.2.01.1210092044210.27589@HIDDEN>
	<AA8EBE30-F563-46B7-A056-D88CBDDB99B3@HIDDEN>
	<alpine.GSO.2.01.1210100822060.27589@HIDDEN>
	<55F37BA2-034E-4223-B6E4-87926F6BB691@HIDDEN>
	<alpine.GSO.2.01.1210101102210.18471@HIDDEN>
User-Agent: Alpine 2.01 (GSO 1266 2009-07-14)
MIME-Version: 1.0
Content-Type: TEXT/PLAIN; charset=US-ASCII; format=flowed
X-Greylist: Sender IP whitelisted, not delayed by milter-greylist-4.2.2
	(blade.simplesystems.org [65.66.246.90]);
	Thu, 11 Oct 2012 09:18:44 -0500 (CDT)
X-detected-operating-system: by eggs.gnu.org: Solaris 10 (beta)
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6 (newer, 3)
X-Received-From: 208.118.235.17
X-Spam-Score: -4.2 (----)
X-Debbugs-Envelope-To: submit
Cc: bug-libtool@HIDDEN, "12613 <at> debbugs.gnu.org" <12613 <at> debbugs.gnu.org>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -4.2 (----)

On Wed, 10 Oct 2012, Bob Friesenhahn wrote:

> On Wed, 10 Oct 2012, Gary V. Vaughan wrote:
>> 
>> I assume you are using run-time linking on AIX?  I find almost all free 
>> software requires CFLAGS=-brtl.
>
> Yes.  The GraphicsMagick configure script is automatically adding it.

I did some more investigation and found that my above statement was 
incorrect.  The GraphicsMagick configure script is not automatically 
adding -brtl to LDFLAGS, rather, I have a wrapper script used on the 
build machine which is passing -brtl via LDFLAGS to the configure 
script.  This option is then properly used while compiling the 
GraphicsMagick objects, but LDFLAGS is being ignored while building 
libltdl.  Ignoring user-provided LDFLAGS seems unkind.

Libltdl's Makefile.inc makes no reference to LDFLAGS (ignores it) but 
it respects AM_LDFLAGS.  The GraphicsMagick Makefile.am declares a 
starting AM_LDFLAGS which is empty, and then libltdl's Makefile.inc 
fragment adds to this via += syntax.

Regarding a correctly installable libltdl, I am experimenting with 
initializing libltdl like

LTDL_INIT([nonrecursive installable])

and this seems to help in that a convencience library is not copied 
into the application library.  I am not sure what the ramifications of 
this change to users would be though.

I am thinking that I should delay the forthcoming release of my 
software and take the time to unbundle libltdl because bundling is 
clearly not helping in any way.

Bob
-- 
Bob Friesenhahn
bfriesen@HIDDEN, http://www.simplesystems.org/users/bfriesen/
GraphicsMagick Maintainer,    http://www.GraphicsMagick.org/




Information forwarded to bug-libtool@HIDDEN:
bug#12613; Package libtool. Full text available.

Message received at 12613 <at> debbugs.gnu.org:


Received: (at 12613) by debbugs.gnu.org; 11 Oct 2012 14:19:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 11 10:19:39 2012
Received: from localhost ([127.0.0.1]:39577 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TMJbu-0003yS-F2
	for submit <at> debbugs.gnu.org; Thu, 11 Oct 2012 10:19:38 -0400
Received: from blade.simplesystems.org ([65.66.246.74]:40144)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <bfriesen@HIDDEN>) id 1TMJbr-0003yF-2R
	for 12613 <at> debbugs.gnu.org; Thu, 11 Oct 2012 10:19:36 -0400
Received: from freddy.simplesystems.org (freddy.simplesystems.org
	[65.66.246.65])
	by blade.simplesystems.org (8.14.4+Sun/8.14.4) with ESMTP id
	q9BEIiA4025294; Thu, 11 Oct 2012 09:18:44 -0500 (CDT)
Date: Thu, 11 Oct 2012 09:18:43 -0500 (CDT)
From: Bob Friesenhahn <bfriesen@HIDDEN>
X-X-Sender: bfriesen@HIDDEN
To: "Gary V. Vaughan" <gary@HIDDEN>
Subject: Re: bug#12613: Subordinate libltdl builds convenience library when
	it should build shared library
In-Reply-To: <alpine.GSO.2.01.1210101102210.18471@HIDDEN>
Message-ID: <alpine.GSO.2.01.1210110856430.27589@HIDDEN>
References: <alpine.GSO.2.01.1210092044210.27589@HIDDEN>
	<AA8EBE30-F563-46B7-A056-D88CBDDB99B3@HIDDEN>
	<alpine.GSO.2.01.1210100822060.27589@HIDDEN>
	<55F37BA2-034E-4223-B6E4-87926F6BB691@HIDDEN>
	<alpine.GSO.2.01.1210101102210.18471@HIDDEN>
User-Agent: Alpine 2.01 (GSO 1266 2009-07-14)
MIME-Version: 1.0
Content-Type: TEXT/PLAIN; charset=US-ASCII; format=flowed
X-Greylist: Sender IP whitelisted, not delayed by milter-greylist-4.2.2
	(blade.simplesystems.org [65.66.246.90]);
	Thu, 11 Oct 2012 09:18:44 -0500 (CDT)
X-Spam-Score: 0.8 (/)
X-Debbugs-Envelope-To: 12613
Cc: bug-libtool@HIDDEN, "12613 <at> debbugs.gnu.org" <12613 <at> debbugs.gnu.org>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 0.8 (/)

On Wed, 10 Oct 2012, Bob Friesenhahn wrote:

> On Wed, 10 Oct 2012, Gary V. Vaughan wrote:
>> 
>> I assume you are using run-time linking on AIX?  I find almost all free 
>> software requires CFLAGS=-brtl.
>
> Yes.  The GraphicsMagick configure script is automatically adding it.

I did some more investigation and found that my above statement was 
incorrect.  The GraphicsMagick configure script is not automatically 
adding -brtl to LDFLAGS, rather, I have a wrapper script used on the 
build machine which is passing -brtl via LDFLAGS to the configure 
script.  This option is then properly used while compiling the 
GraphicsMagick objects, but LDFLAGS is being ignored while building 
libltdl.  Ignoring user-provided LDFLAGS seems unkind.

Libltdl's Makefile.inc makes no reference to LDFLAGS (ignores it) but 
it respects AM_LDFLAGS.  The GraphicsMagick Makefile.am declares a 
starting AM_LDFLAGS which is empty, and then libltdl's Makefile.inc 
fragment adds to this via += syntax.

Regarding a correctly installable libltdl, I am experimenting with 
initializing libltdl like

LTDL_INIT([nonrecursive installable])

and this seems to help in that a convencience library is not copied 
into the application library.  I am not sure what the ramifications of 
this change to users would be though.

I am thinking that I should delay the forthcoming release of my 
software and take the time to unbundle libltdl because bundling is 
clearly not helping in any way.

Bob
-- 
Bob Friesenhahn
bfriesen@HIDDEN, http://www.simplesystems.org/users/bfriesen/
GraphicsMagick Maintainer,    http://www.GraphicsMagick.org/




Information forwarded to bug-libtool@HIDDEN:
bug#12613; Package libtool. Full text available.

Message received at 12613 <at> debbugs.gnu.org:


Received: (at 12613) by debbugs.gnu.org; 10 Oct 2012 16:14:52 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 10 12:14:52 2012
Received: from localhost ([127.0.0.1]:37800 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TLyvr-0006cX-Sa
	for submit <at> debbugs.gnu.org; Wed, 10 Oct 2012 12:14:52 -0400
Received: from blade.simplesystems.org ([65.66.246.74]:37679)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <bfriesen@HIDDEN>) id 1TLyvo-0006cG-PB
	for 12613 <at> debbugs.gnu.org; Wed, 10 Oct 2012 12:14:50 -0400
Received: from freddy.simplesystems.org (freddy.simplesystems.org
	[65.66.246.65])
	by blade.simplesystems.org (8.14.4+Sun/8.14.4) with ESMTP id
	q9AGE24Y020347; Wed, 10 Oct 2012 11:14:03 -0500 (CDT)
Date: Wed, 10 Oct 2012 11:14:02 -0500 (CDT)
From: Bob Friesenhahn <bfriesen@HIDDEN>
X-X-Sender: bfriesen@HIDDEN
To: "Gary V. Vaughan" <gary@HIDDEN>
Subject: Re: bug#12613: Subordinate libltdl builds convenience library when
	it should build shared library
In-Reply-To: <55F37BA2-034E-4223-B6E4-87926F6BB691@HIDDEN>
Message-ID: <alpine.GSO.2.01.1210101102210.18471@HIDDEN>
References: <alpine.GSO.2.01.1210092044210.27589@HIDDEN>
	<AA8EBE30-F563-46B7-A056-D88CBDDB99B3@HIDDEN>
	<alpine.GSO.2.01.1210100822060.27589@HIDDEN>
	<55F37BA2-034E-4223-B6E4-87926F6BB691@HIDDEN>
User-Agent: Alpine 2.01 (GSO 1266 2009-07-14)
MIME-Version: 1.0
Content-Type: TEXT/PLAIN; format=flowed; charset=US-ASCII
X-Greylist: Sender IP whitelisted, not delayed by milter-greylist-4.2.2
	(blade.simplesystems.org [65.66.246.90]);
	Wed, 10 Oct 2012 11:14:03 -0500 (CDT)
X-Spam-Score: 0.8 (/)
X-Debbugs-Envelope-To: 12613
Cc: "12613 <at> debbugs.gnu.org" <12613 <at> debbugs.gnu.org>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 0.8 (/)

On Wed, 10 Oct 2012, Gary V. Vaughan wrote:
>
> I assume you are using run-time linking on AIX?  I find almost all free software requires CFLAGS=-brtl.

Yes.  The GraphicsMagick configure script is automatically adding it.

>> If I then configure with --enable-ltdl-install, I see that libltdl 
>> is being built as a shared library but there is a bug in that the 
>> dependent software is being told to link with already installed 
>> /usr/local/lib/libltdl.la rather than the uninstalled libltdl in 
>> the build tree.
>
> That seems like the correct behaviour to me, your package should use 
> the system libltdl if it is new enough unless you specificaly 
> request the bundled version.

No that is the wrong behavior since the application is linked with a 
libltdl different than the one that it is installing.  It should link 
against the libltdl that it is installing.  Anything else is a bug.

I think that supporting installing a bundled libltd is a bug.  It is a 
very dangerous feature.  The dangers become very evident after one 
does 'make uninstall' after doing 'make install' on a system which 
already included the same version of libltdl so previously-existing 
libltdl is now completely deleted.

Linking a libltdl convenience library into a library to be installed 
is also a bug.

> No need to install autoconf or GNU m4 to build a distributed libtool 
> tarball, just ./configure && make all check && sudo make install.

Ok, better than I thought.  But still libtool stuff gets installed 
when the user only intended/needed to install libltdl.

> worrying about fitting into the libtool release schedule.  I think 
> that decoupling would also make it much easier for GraphicsMagick 
> and others to just depend on (new-enough) installed system libltdl, 
> and fix your problems.

At this point in time I am thinking about stripping bundled libltdl 
out of GraphicsMagick and treating libltdl like any other library that 
it optionally depends on.

> I'm very open to discussion on those possibilities on the appropriate lists.

Yes, feature discussions do not belong here.

Bob
-- 
Bob Friesenhahn
bfriesen@HIDDEN, http://www.simplesystems.org/users/bfriesen/
GraphicsMagick Maintainer,    http://www.GraphicsMagick.org/




Information forwarded to bug-libtool@HIDDEN:
bug#12613; Package libtool. Full text available.

Message received at 12613 <at> debbugs.gnu.org:


Received: (at 12613) by debbugs.gnu.org; 10 Oct 2012 14:44:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 10 10:44:06 2012
Received: from localhost ([127.0.0.1]:37568 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TLxW1-0004Sm-Cq
	for submit <at> debbugs.gnu.org; Wed, 10 Oct 2012 10:44:06 -0400
Received: from caiajhbdcagg.dreamhost.com ([208.97.132.66]:32901
	helo=homiemail-a15.g.dreamhost.com)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <gary@HIDDEN>) id 1TLxVx-0004SF-Jb
	for 12613 <at> debbugs.gnu.org; Wed, 10 Oct 2012 10:44:03 -0400
Received: from homiemail-a15.g.dreamhost.com (localhost [127.0.0.1])
	by homiemail-a15.g.dreamhost.com (Postfix) with ESMTP id 5B5F076C06E;
	Wed, 10 Oct 2012 07:43:21 -0700 (PDT)
Received: from [192.168.1.13] (unknown [180.183.139.63])
	(using TLSv1 with cipher AES128-SHA (128/128 bits))
	(No client certificate requested)
	(Authenticated sender: gary@HIDDEN)
	by homiemail-a15.g.dreamhost.com (Postfix) with ESMTPSA id 70F8C76C069; 
	Wed, 10 Oct 2012 07:43:17 -0700 (PDT)
Content-Type: text/plain; charset=us-ascii
Mime-Version: 1.0 (Mac OS X Mail 6.2 \(1499\))
Subject: Re: bug#12613: Subordinate libltdl builds convenience library when it
	should build shared library
From: "Gary V. Vaughan" <gary@HIDDEN>
In-Reply-To: <alpine.GSO.2.01.1210100822060.27589@HIDDEN>
Date: Wed, 10 Oct 2012 21:43:14 +0700
Content-Transfer-Encoding: quoted-printable
Message-Id: <55F37BA2-034E-4223-B6E4-87926F6BB691@HIDDEN>
References: <alpine.GSO.2.01.1210092044210.27589@HIDDEN>
	<AA8EBE30-F563-46B7-A056-D88CBDDB99B3@HIDDEN>
	<alpine.GSO.2.01.1210100822060.27589@HIDDEN>
To: Bob Friesenhahn <bfriesen@HIDDEN>
X-Mailer: Apple Mail (2.1499)
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
	has
	identified this incoming email as possible spam. The original message
	has been attached to this so you can view it (if it isn't spam) or
	label similar future email.  If you have any questions, see
	the administrator of that system for details.
	Content preview:  Hi Bob, On 10 Oct 2012, at 21:09,
	Bob Friesenhahn <bfriesen@HIDDEN>
	wrote: > On Wed, 10 Oct 2012, Gary V. Vaughan wrote: >> On Oct 10, 2012,
	at 9:31 AM,
	Bob Friesenhahn <bfriesen@HIDDEN> wrote: >>> Ltdl
	is configured like >>> >>> LTDL_INIT([convenience nonrecursive]) >>
	^^^^^^^^^^^
	>> >>> I noticed that all of the libltdl objects are being included
	into
	my library at link time and that libltdl symbols are being included my
	library's
	.exp exports file. This is in spite of requesting that the libltdl
	library
	be built and installed. >> >> It seems that specifying a convenience
	library
	in configure.ac takes precedence over specifying an installable (i.e.
	not-convenience)
	on the command line. I can't find any documentation to confirm or deny
	that...
	when we've decided the precedence, we need to document it. > > This same
	logic used to work as expected (at least from what I remember). I am
	likely
	wrong though and perhaps this AIX linkage error (which is another bug)
	simply drew my attention to the problem. [...] 
	Content analysis details:   (1.5 points, 10.0 required)
	pts rule name              description
	---- ----------------------
	--------------------------------------------------
	-0.0 RCVD_IN_DNSWL_NONE RBL: Sender listed at http://www.dnswl.org/,
	no trust [208.97.132.66 listed in list.dnswl.org]
	0.7 SPF_SOFTFAIL SPF: sender does not match SPF record (softfail)
	0.8 BAYES_50               BODY: Bayes spam probability is 40 to 60%
	[score: 0.5000]
X-Debbugs-Envelope-To: 12613
Cc: "12613 <at> debbugs.gnu.org" <12613 <at> debbugs.gnu.org>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org", has
 identified this incoming email as possible spam.  The original message
 has been attached to this so you can view it (if it isn't spam) or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Hi Bob, On 10 Oct 2012, at 21:09, Bob Friesenhahn <bfriesen@HIDDEN>
    wrote: > On Wed, 10 Oct 2012, Gary V. Vaughan wrote: >> On Oct 10, 2012,
   at 9:31 AM, Bob Friesenhahn <bfriesen@HIDDEN> wrote: >>> Ltdl
    is configured like >>> >>> LTDL_INIT([convenience nonrecursive]) >> ^^^^^^^^^^^
    >> >>> I noticed that all of the libltdl objects are being included into
   my library at link time and that libltdl symbols are being included my library's
    .exp exports file. This is in spite of requesting that the libltdl library
    be built and installed. >> >> It seems that specifying a convenience library
    in configure.ac takes precedence over specifying an installable (i.e. not-convenience)
    on the command line. I can't find any documentation to confirm or deny that...
    when we've decided the precedence, we need to document it. > > This same
   logic used to work as expected (at least from what I remember). I am likely
    wrong though and perhaps this AIX linkage error (which is another bug) simply
    drew my attention to the problem. [...] 
 
 Content analysis details:   (1.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at http://www.dnswl.org/, no
                             trust
                             [208.97.132.66 listed in list.dnswl.org]
  0.7 SPF_SOFTFAIL           SPF: sender does not match SPF record (softfail)
  0.8 BAYES_50               BODY: Bayes spam probability is 40 to 60%
                             [score: 0.5000]

Hi Bob,

On 10 Oct 2012, at 21:09, Bob Friesenhahn <bfriesen@HIDDEN> =
wrote:
> On Wed, 10 Oct 2012, Gary V. Vaughan wrote:
>> On Oct 10, 2012, at 9:31 AM, Bob Friesenhahn =
<bfriesen@HIDDEN> wrote:
>>> Ltdl is configured like
>>>=20
>>> LTDL_INIT([convenience nonrecursive])
>>            ^^^^^^^^^^^
>>=20
>>> I noticed that all of the libltdl objects are being included into my =
library at link time and that libltdl symbols are being included my =
library's .exp exports file.  This is in spite of requesting that the =
libltdl library be built and installed.
>>=20
>> It seems that specifying a convenience library in configure.ac takes =
precedence over specifying an installable (i.e. not-convenience) on the =
command line.  I can't find any documentation to confirm or deny that... =
when we've decided the precedence, we need to document it.
>=20
> This same logic used to work as expected (at least from what I =
remember).  I am likely wrong though and perhaps this AIX linkage error =
(which is another bug) simply drew my attention to the problem.

I assume you are using run-time linking on AIX?  I find almost all free =
software requires CFLAGS=3D-brtl.

> What I was expecting is that if there is already an installed libltdl =
and the user has not specified --enable-ltdl-install that the installed =
libltdl is used.  If --enable-ltdl-install is specified then an =
installable version of libltdl should be built (and used).  If libltdl =
is not installed and the user has not specified --enable-ltdl-install, =
then it should be built as a convenience library and absorbed into the =
using application/library.

That's a reasonable mode of operation.

Would you mind writing a patch to our docs, and adding an appropriate =
XFAIL test to tests/configure-iface.at in the vein of the other tests =
cases in that file that link against an already installed libltdl?  We =
need to be completely clear about the semantics of --enable-ltdl-install =
both with and without an already installed libltdl, and what changes =
when --with-included-ltdl and/or --enable-ltdl-convenience (and their =
LTDL_INIT equivalents).  Also what is the precedence between LTDL_INIT =
options supplied by the developer, and configure-time options supplied =
by the package builder.  I tend to think LTDL_INIT should set the =
defaults, which can then be changed with configure-time options.

Given a proper description of how all these things should interact, and =
a test case or two to get me started, I'll be happy to chase down the =
first bug from there, and we can then analyse the other one in isolation =
afterwards.  Feel free to raise a separate bug report if you want to be =
sure we don't lose it.

>> Does it work the way you expect if you remove the convenience =
declaration from the LTDL_INIT invocation?
>=20
> A quick test (under OpenIndiana) with
>=20
> LTDL_INIT([nonrecursive])
>=20
> reveals that libltdl is still being built as a convenience library =
when libltdl is already installed and no special configure options were =
provided.  However, the build is correctly using the installed libltdl =
so there is no harm.

Yuck, that sound completely fubar :(  How come no-one else noticed this =
bug after a year in the wild! :-o

> If I then configure with --enable-ltdl-install, I see that libltdl is =
being built as a shared library but there is a bug in that the dependent =
software is being told to link with already installed =
/usr/local/lib/libltdl.la rather than the uninstalled libltdl in the =
build tree.

That seems like the correct behaviour to me, your package should use the =
system libltdl if it is new enough unless you specificaly request the =
bundled version.

> If I configure with --enable-ltdl-install --with-included-ltdl then we =
are back to building a convenience library, with all libltdl symbols =
added to my program's main library (and exported, evil).  In this case =
it is in spite of an already installed libltdl.

The exported symbols are another bug entirely :(  Let's push that one =
back until we solve the other two, first.  Again, feel free to raise a =
new bug report to track that one too.

> Regardless, I don't see how bundled libltdl could work as hoped if the =
user forgets to add --enable-ltdl-install to the options.  Instead the =
user might get a successful build, but software which does not run after =
installation because the libltdl it was linked with is missing.

I think that without --enable-ltdl-install, it makes sense to roll the =
bundled libltdl as a convenience library.

> Bare machines without libltdl are pretty rare these days, and removing =
libltdl (for testing) might cause the system to to stop functioning =
normally.
>=20
> It seems that bundling libltdl is a pox to my package.  In spite of =
supporting libldtl as a convenience library, since its symbols get added =
to my program's main library (usable by other software) there is a =
problem since it includes and exports libltdl symbols and might conflict =
with some libltdl installed later.
>=20
> It is a bit of a problem that libltdl is not its own stand-alone =
package and is instead part of libtool.  Since it is part of libtool, it =
is necessary to install autoconf in order to install libtool (and =
thereby libltdl).  If libltdl was to be unbundled from my application, I =
would not want to have to tell the user that they need to install latest =
GNU m4, autoconf, and libtool in order to be able to use modules.

No need to install autoconf or GNU m4 to build a distributed libtool =
tarball, just ./configure && make all check && sudo make install.

Nonetheless, I've been musing about the pros and cons of separating =
libltdl into a separate package, mostly to try to simplify libtool =
itself enough that we can merge it into automake-ng or gnulib... and =
also because despite several years of pecking away at it, libltdl is =
neither pleasant to work with, or very well architected, so it would be =
nice to have the option to write a complete replacement without worrying =
about fitting into the libtool release schedule.  I think that =
decoupling would also make it much easier for GraphicsMagick and others =
to just depend on (new-enough) installed system libltdl, and fix your =
problems.

I'm very open to discussion on those possibilities on the appropriate =
lists.

Cheers,
--=20
Gary V. Vaughan (gary AT gnu DOT org)=




Information forwarded to bug-libtool@HIDDEN:
bug#12613; Package libtool. Full text available.

Message received at 12613 <at> debbugs.gnu.org:


Received: (at 12613) by debbugs.gnu.org; 10 Oct 2012 14:10:23 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 10 10:10:23 2012
Received: from localhost ([127.0.0.1]:37547 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TLwzO-0003gA-Qj
	for submit <at> debbugs.gnu.org; Wed, 10 Oct 2012 10:10:23 -0400
Received: from blade.simplesystems.org ([65.66.246.74]:37205)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <bfriesen@HIDDEN>) id 1TLwzL-0003fp-7Y
	for 12613 <at> debbugs.gnu.org; Wed, 10 Oct 2012 10:10:21 -0400
Received: from freddy.simplesystems.org (freddy.simplesystems.org
	[65.66.246.65])
	by blade.simplesystems.org (8.14.4+Sun/8.14.4) with ESMTP id
	q9AE9XVc019624; Wed, 10 Oct 2012 09:09:33 -0500 (CDT)
Date: Wed, 10 Oct 2012 09:09:33 -0500 (CDT)
From: Bob Friesenhahn <bfriesen@HIDDEN>
X-X-Sender: bfriesen@HIDDEN
To: "Gary V. Vaughan" <gary@HIDDEN>
Subject: Re: bug#12613: Subordinate libltdl builds convenience library when
	it should build shared library
In-Reply-To: <AA8EBE30-F563-46B7-A056-D88CBDDB99B3@HIDDEN>
Message-ID: <alpine.GSO.2.01.1210100822060.27589@HIDDEN>
References: <alpine.GSO.2.01.1210092044210.27589@HIDDEN>
	<AA8EBE30-F563-46B7-A056-D88CBDDB99B3@HIDDEN>
User-Agent: Alpine 2.01 (GSO 1266 2009-07-14)
MIME-Version: 1.0
Content-Type: TEXT/PLAIN; charset=US-ASCII; format=flowed
X-Greylist: Sender IP whitelisted, not delayed by milter-greylist-4.2.2
	(blade.simplesystems.org [65.66.246.90]);
	Wed, 10 Oct 2012 09:09:33 -0500 (CDT)
X-Spam-Score: 0.8 (/)
X-Debbugs-Envelope-To: 12613
Cc: "12613 <at> debbugs.gnu.org" <12613 <at> debbugs.gnu.org>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 0.8 (/)

On Wed, 10 Oct 2012, Gary V. Vaughan wrote:

> Hi Bob,
>
> What revision of Libtool?

The released version 2.4.2.

> On Oct 10, 2012, at 9:31 AM, Bob Friesenhahn <bfriesen@HIDDEN> wrote:
>> Ltdl is configured like
>>
>> LTDL_INIT([convenience nonrecursive])
>             ^^^^^^^^^^^
>
>> I noticed that all of the libltdl objects are being included into 
>> my library at link time and that libltdl symbols are being included 
>> my library's .exp exports file.  This is in spite of requesting 
>> that the libltdl library be built and installed.
>
> It seems that specifying a convenience library in configure.ac takes 
> precedence over specifying an installable (i.e. not-convenience) on 
> the command line.  I can't find any documentation to confirm or deny 
> that... when we've decided the precedence, we need to document it.

This same logic used to work as expected (at least from what I 
remember).  I am likely wrong though and perhaps this AIX linkage 
error (which is another bug) simply drew my attention to the problem.

What I was expecting is that if there is already an installed libltdl 
and the user has not specified --enable-ltdl-install that the 
installed libltdl is used.  If --enable-ltdl-install is specified then 
an installable version of libltdl should be built (and used).  If 
libltdl is not installed and the user has not specified 
--enable-ltdl-install, then it should be built as a convenience 
library and absorbed into the using application/library.

> Does it work the way you expect if you remove the convenience declaration from the LTDL_INIT invocation?

A quick test (under OpenIndiana) with

LTDL_INIT([nonrecursive])

reveals that libltdl is still being built as a convenience library 
when libltdl is already installed and no special configure options 
were provided.  However, the build is correctly using the installed 
libltdl so there is no harm.

If I then configure with --enable-ltdl-install, I see that libltdl is 
being built as a shared library but there is a bug in that the 
dependent software is being told to link with already installed 
/usr/local/lib/libltdl.la rather than the uninstalled libltdl in the 
build tree.

If I configure with --enable-ltdl-install --with-included-ltdl then we 
are back to building a convenience library, with all libltdl symbols 
added to my program's main library (and exported, evil).  In this case 
it is in spite of an already installed libltdl.

Regardless, I don't see how bundled libltdl could work as hoped if the 
user forgets to add --enable-ltdl-install to the options.  Instead the 
user might get a successful build, but software which does not run 
after installation because the libltdl it was linked with is missing.

Bare machines without libltdl are pretty rare these days, and removing 
libltdl (for testing) might cause the system to to stop functioning 
normally.

It seems that bundling libltdl is a pox to my package.  In spite of 
supporting libldtl as a convenience library, since its symbols get 
added to my program's main library (usable by other software) there is 
a problem since it includes and exports libltdl symbols and might 
conflict with some libltdl installed later.

It is a bit of a problem that libltdl is not its own stand-alone 
package and is instead part of libtool.  Since it is part of libtool, 
it is necessary to install autoconf in order to install libtool (and 
thereby libltdl).  If libltdl was to be unbundled from my application, 
I would not want to have to tell the user that they need to install 
latest GNU m4, autoconf, and libtool in order to be able to use 
modules.

Bob
-- 
Bob Friesenhahn
bfriesen@HIDDEN, http://www.simplesystems.org/users/bfriesen/
GraphicsMagick Maintainer,    http://www.GraphicsMagick.org/




Information forwarded to bug-libtool@HIDDEN:
bug#12613; Package libtool. Full text available.

Message received at 12613 <at> debbugs.gnu.org:


Received: (at 12613) by debbugs.gnu.org; 10 Oct 2012 03:30:07 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Oct 09 23:30:07 2012
Received: from localhost ([127.0.0.1]:36562 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TLmzm-0004DM-Md
	for submit <at> debbugs.gnu.org; Tue, 09 Oct 2012 23:30:06 -0400
Received: from caiajhbdcbef.dreamhost.com ([208.97.132.145]:47048
	helo=homiemail-a20.g.dreamhost.com)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <gary@HIDDEN>) id 1TLmzk-0004Cr-Bd
	for 12613 <at> debbugs.gnu.org; Tue, 09 Oct 2012 23:30:05 -0400
Received: from homiemail-a20.g.dreamhost.com (localhost [127.0.0.1])
	by homiemail-a20.g.dreamhost.com (Postfix) with ESMTP id D72B77EC061;
	Tue,  9 Oct 2012 20:29:26 -0700 (PDT)
Received: from [192.168.1.11] (unknown [180.183.139.63])
	(using TLSv1 with cipher AES128-SHA (128/128 bits))
	(No client certificate requested)
	(Authenticated sender: gary@HIDDEN)
	by homiemail-a20.g.dreamhost.com (Postfix) with ESMTPSA id 779C37EC060; 
	Tue,  9 Oct 2012 20:29:26 -0700 (PDT)
References: <alpine.GSO.2.01.1210092044210.27589@HIDDEN>
Mime-Version: 1.0 (1.0)
In-Reply-To: <alpine.GSO.2.01.1210092044210.27589@HIDDEN>
Content-Type: text/plain;
	charset=us-ascii
Content-Transfer-Encoding: quoted-printable
Message-Id: <AA8EBE30-F563-46B7-A056-D88CBDDB99B3@HIDDEN>
X-Mailer: iPad Mail (10A403)
From: "Gary V. Vaughan" <gary@HIDDEN>
Subject: Re: bug#12613: Subordinate libltdl builds convenience library when it
	should build shared library
Date: Wed, 10 Oct 2012 10:29:48 +0700
To: Bob Friesenhahn <bfriesen@HIDDEN>
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
	has
	identified this incoming email as possible spam. The original message
	has been attached to this so you can view it (if it isn't spam) or
	label similar future email.  If you have any questions, see
	the administrator of that system for details.
	Content preview:  Hi Bob, What revision of Libtool? On Oct 10, 2012,
	at 9:31 AM,
	Bob Friesenhahn <bfriesen@HIDDEN> wrote: > Ltdl is
	configured
	like > > LTDL_INIT([convenience nonrecursive]) ^^^^^^^^^^^ [...] 
	Content analysis details:   (1.5 points, 10.0 required)
	pts rule name              description
	---- ----------------------
	--------------------------------------------------
	-0.0 RCVD_IN_DNSWL_NONE RBL: Sender listed at http://www.dnswl.org/,
	no trust [208.97.132.145 listed in list.dnswl.org]
	0.7 SPF_SOFTFAIL SPF: sender does not match SPF record (softfail)
	0.8 BAYES_50               BODY: Bayes spam probability is 40 to 60%
	[score: 0.5000]
	0.0 MIME_QP_LONG_LINE RAW: Quoted-printable line longer than 76 chars
X-Debbugs-Envelope-To: 12613
Cc: "12613 <at> debbugs.gnu.org" <12613 <at> debbugs.gnu.org>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org", has
 identified this incoming email as possible spam.  The original message
 has been attached to this so you can view it (if it isn't spam) or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Hi Bob, What revision of Libtool? On Oct 10, 2012, at 9:31
    AM, Bob Friesenhahn <bfriesen@HIDDEN> wrote: > Ltdl is configured
    like > > LTDL_INIT([convenience nonrecursive]) ^^^^^^^^^^^ [...] 
 
 Content analysis details:   (1.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at http://www.dnswl.org/, no
                             trust
                             [208.97.132.145 listed in list.dnswl.org]
  0.7 SPF_SOFTFAIL           SPF: sender does not match SPF record (softfail)
  0.8 BAYES_50               BODY: Bayes spam probability is 40 to 60%
                             [score: 0.5000]
  0.0 MIME_QP_LONG_LINE      RAW: Quoted-printable line longer than 76 chars

Hi Bob,

What revision of Libtool?

On Oct 10, 2012, at 9:31 AM, Bob Friesenhahn <bfriesen@HIDDEN> w=
rote:
> Ltdl is configured like
>=20
> LTDL_INIT([convenience nonrecursive])
             ^^^^^^^^^^^

> I noticed that all of the libltdl objects are being included into my libra=
ry at link time and that libltdl symbols are being included my library's .ex=
p exports file.  This is in spite of requesting that the libltdl library be b=
uilt and installed.

It seems that specifying a convenience library in configure.ac takes precede=
nce over specifying an installable (i.e. not-convenience) on the command lin=
e.  I can't find any documentation to confirm or deny that... when we've dec=
ided the precedence, we need to document it.

Does it work the way you expect if you remove the convenience declaration fr=
om the LTDL_INIT invocation?

Cheers,
--=20
Gary V. Vaughan (gary AT gnu DOT org)





Information forwarded to bug-libtool@HIDDEN:
bug#12613; Package libtool. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 10 Oct 2012 02:31:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Oct 09 22:31:53 2012
Received: from localhost ([127.0.0.1]:36525 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TLm5R-0002lH-CT
	for submit <at> debbugs.gnu.org; Tue, 09 Oct 2012 22:31:53 -0400
Received: from eggs.gnu.org ([208.118.235.92]:39617)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <bfriesen@HIDDEN>) id 1TLm5N-0002l3-LW
	for submit <at> debbugs.gnu.org; Tue, 09 Oct 2012 22:31:51 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <bfriesen@HIDDEN>) id 1TLm4g-0005kG-SL
	for submit <at> debbugs.gnu.org; Tue, 09 Oct 2012 22:31:08 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-6.9 required=5.0 tests=BAYES_00,RCVD_IN_DNSWL_HI
	autolearn=unavailable version=3.3.2
Received: from lists.gnu.org ([208.118.235.17]:43113)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <bfriesen@HIDDEN>) id 1TLm4g-0005kC-P2
	for submit <at> debbugs.gnu.org; Tue, 09 Oct 2012 22:31:06 -0400
Received: from eggs.gnu.org ([208.118.235.92]:49818)
	by lists.gnu.org with esmtp (Exim 4.71)
	(envelope-from <bfriesen@HIDDEN>) id 1TLm4f-0007p3-Eo
	for bug-libtool@HIDDEN; Tue, 09 Oct 2012 22:31:06 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <bfriesen@HIDDEN>) id 1TLm4e-0005jk-5T
	for bug-libtool@HIDDEN; Tue, 09 Oct 2012 22:31:05 -0400
Received: from blade.simplesystems.org ([65.66.246.74]:35697)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <bfriesen@HIDDEN>) id 1TLm4d-0005jg-TB
	for bug-libtool@HIDDEN; Tue, 09 Oct 2012 22:31:04 -0400
Received: from freddy.simplesystems.org (freddy.simplesystems.org
	[65.66.246.65])
	by blade.simplesystems.org (8.14.4+Sun/8.14.4) with ESMTP id
	q9A2V2PE016952
	for <bug-libtool@HIDDEN>; Tue, 9 Oct 2012 21:31:02 -0500 (CDT)
Date: Tue, 9 Oct 2012 21:31:02 -0500 (CDT)
From: Bob Friesenhahn <bfriesen@HIDDEN>
X-X-Sender: bfriesen@HIDDEN
To: Libtool Bugs List <bug-libtool@HIDDEN>
Subject: Subordinate libltdl builds convenience library when it should build
	shared library
Message-ID: <alpine.GSO.2.01.1210092044210.27589@HIDDEN>
User-Agent: Alpine 2.01 (GSO 1266 2009-07-14)
MIME-Version: 1.0
Content-Type: TEXT/PLAIN; format=flowed; charset=US-ASCII
X-Greylist: Sender IP whitelisted, not delayed by milter-greylist-4.2.2
	(blade.simplesystems.org [65.66.246.90]);
	Tue, 09 Oct 2012 21:31:02 -0500 (CDT)
X-detected-operating-system: by eggs.gnu.org: Solaris 10 (beta)
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6 (newer, 3)
X-Received-From: 208.118.235.17
X-Spam-Score: -4.2 (----)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -4.2 (----)

GraphicsMagick builds libltdl non-recursively as a subordinate 
component by including its Makefile.inc and using the ${LIBLTDL} and 
${LTDLDEPS} values it produces in the configure script.

Ltdl is configured like

LT_CONFIG_LTDL_DIR([ltdl])
LTDL_INIT([convenience nonrecursive])

Today while testing with the IBM XLC compiler on an AIX machine which 
does not have libltdl installed, I noticed that GraphicsMagick was 
unable to link, with this error:

1586-281 (E) A type mismatch was detected for symbol "dlopen_LTX_get_vtable".

This issue is noticed with and without the --enable-ltdl-install 
option supplied.  The --enable-ltdl-convenience option was not 
supplied.

I noticed that all of the libltdl objects are being included into my 
library at link time and that libltdl symbols are being included my 
library's .exp exports file.  This is in spite of requesting that the 
libltdl library be built and installed.

It seems that libltdl was built as a static library rather than a 
shared library and it is being used as a convenience library 
(libltdlc.a) rather than being used as a (to be installed) shared 
library dependency as it should be.

The build was configured with

   --enable-shared --disable-static --enable-ltdl-install

so it seems that libltdl should have been built as a shared library.

Here is relevant configure output:

checking how to hardcode library paths into programs... immediate
checking for shl_load... no
checking for shl_load in -ldld... no
checking for dlopen... yes
checking whether a program can dlopen itself... yes
checking whether a statically linked program can dlopen itself... yes
checking whether stripping libraries is possible... no
checking if libtool supports shared libraries... yes
checking whether to build shared libraries... yes
checking whether to build static libraries... no
checking whether we are using the GNU C++ compiler... no
checking whether xlC_r accepts -g... yes
checking dependency style of xlC_r... xlc
checking how to run the C++ preprocessor... xlC_r -E
checking whether the xlC_r linker (/bin/ld) supports shared libraries... yes
checking for xlC_r option to produce PIC...  -DPIC
checking if xlC_r PIC flag  -DPIC works... yes
checking if xlC_r static flag -bnso -bI:/lib/syscalls.exp works... no
checking if xlC_r supports -c -o file.o... yes
checking if xlC_r supports -c -o file.o... (cached) yes
checking whether the xlC_r linker (/bin/ld) supports shared libraries... yes
checking dynamic linker characteristics... aix7.1.0.0 ld.so
checking how to hardcode library paths into programs... immediate
checking which extension is used for runtime loadable modules... .so
checking which variable specifies run-time module search path... LIBPATH
checking for the default library search path... /lib /usr/lib
checking for library containing dlopen... none required
checking for dlerror... yes
checking for shl_load... (cached) no
checking for shl_load in -ldld... (cached) no
checking for dld_link in -ldld... no
checking for _ prefix in compiled symbols... no
checking whether deplibs are loaded by dlopen... yes
checking for argz.h... no
checking for error_t... no
checking for argz_add... no
checking for argz_append... no
checking for argz_count... no
checking for argz_create_sep... no
checking for argz_insert... no
checking for argz_next... no
checking for argz_stringify... no
checking whether libtool supports -dlopen/-dlpreopen... yes
checking for ltdl.h... no
checking where to find libltdl headers... -I${top_srcdir}/ltdl
checking where to find libltdl library... ${top_build_prefix}ltdl/libltdlc.la

Bob
-- 
Bob Friesenhahn
bfriesen@HIDDEN, http://www.simplesystems.org/users/bfriesen/
GraphicsMagick Maintainer,    http://www.GraphicsMagick.org/




Acknowledgement sent to Bob Friesenhahn <bfriesen@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-libtool@HIDDEN. Full text available.
Report forwarded to bug-libtool@HIDDEN:
bug#12613; Package libtool. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Fri, 31 Oct 2014 17:00:04 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.